apiVersion: apps/v1
kind: Deployment
metadata:
  name: spring-app
spec:
  replicas: {{ .Values.app.replicaCount }}
  selector:
    matchLabels:
      app: {{ .Values.app.name }}
  template:
    metadata:
      labels:
        app: {{ .Values.app.name }}
    spec:
      containers:
        - name: spring-app-container
          image: {{ .Values.app.container.image | quote }}
          env:
            - name: SPRING_DATASOURCE_URL
              value: jdbc:mysql://mysql-service:3306/assignment?allowPublicKeyRetrieval=true&useSSL=false
            - name: SPRING_DATASOURCE_USERNAME
              valueFrom:
                secretKeyRef:
                  name: mysql-secrets
                  key: username  # Using MySQL username from Secret
            - name: SPRING_DATASOURCE_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: mysql-secrets
                  key: password  # Using MySQL password from Secret
            - name: SPRING_PROFILES_ACTIVE
              value: mysql
          ports:
            - containerPort: 8090
          resources:
            requests:
              memory: "256Mi"
              cpu: "250m"
            limits:
              memory: "512Mi"
              cpu: "500m"
          readinessProbe:
            httpGet:
              path: /actuator/health
              port: 8090
            initialDelaySeconds: 15
            periodSeconds: 10
          livenessProbe:
            httpGet:
              path: /actuator/health
              port: 8090
            initialDelaySeconds: 20
            periodSeconds: 20
          volumeMounts:
            - name: check-db-script
              mountPath: /scripts/check-db.sh
              subPath: check-db.sh
      initContainers:
        - name: init-wait-for-db
          image: busybox
          command: ['sh', '-c', 'until nc -z -v -w30 mysql-service 3306; do echo "Waiting for MySQL to be up..."; sleep 5; done;']
          volumeMounts:
            - name: check-db-script
              mountPath: /scripts
              subPath: check-db.sh
      volumes:
        - name: check-db-script
          configMap:
            name: check-db-configmap
